MODULE FractalNetObj_Fractal_v1 EXPORTS FractalNetObj, FractalNetObj_Fractal_v1;

IMPORT Thread, NetObj, StubLib, FractalNetObj, Rd, Wr;
CONST Protocol: StubLib.StubProtocol = 1;

TYPE
      Methods = {getFractalParameters};
      ReturnCodes = {OK};

  PROCEDURE Surrogate_getFractalParameters(self: FractalNetObj.Fractal)
      : FractalNetObj.FractalParams RAISES {NetObj.Error, Thread.Alerted} =

    VAR reuse := FALSE;
        rep: StubLib.DataRep;
        c: StubLib.Conn;
        dataPresent: BOOLEAN; <* NOWARN *>
        res: FractalNetObj.FractalParams;

    BEGIN
      TRY
        c := StubLib.StartCall(self, Protocol);
        TRY
          StubLib.OutInt32(c, ORD(Methods.getFractalParameters));
          rep := StubLib.AwaitResult(c);
          CASE StubLib.InInt32(c, rep) OF
          | ORD(ReturnCodes.OK) =>
            res.type := StubLib.InRef(c, rep, -1);
            res.sx := StubLib.InInteger(c, rep);
            res.sy := StubLib.InInteger(c, rep);
            res.xmin := StubLib.InReal(c, rep);
            res.xmax := StubLib.InReal(c, rep);
            res.ymin := StubLib.InReal(c, rep);
            res.ymax := StubLib.InReal(c, rep);
            res.maxiter := StubLib.InInteger(c, rep);
            reuse := TRUE;
          ELSE
            StubLib.RaiseUnmarshalFailure();
          END
        FINALLY
          StubLib.EndCall(c, reuse);
        END;

      EXCEPT
      | Rd.Failure(ec) => StubLib.RaiseCommFailure(ec);
      | Wr.Failure(ec) => StubLib.RaiseCommFailure(ec);
      END;
      RETURN res;
    END Surrogate_getFractalParameters;

PROCEDURE Invoke(
    c: StubLib.Conn;
    obj: NetObj.T;
    rep: StubLib.DataRep;
    stubProt: StubLib.StubProtocol)
    RAISES {NetObj.Error, Rd.Failure,
            Wr.Failure, Thread.Alerted} =
  VAR t := NARROW(obj, FractalNetObj.Fractal);
  BEGIN
    IF stubProt # Protocol THEN StubLib.RaiseUnmarshalFailure() END;
    TRY
      CASE StubLib.InInt32(c, rep) OF
      | ORD(Methods.getFractalParameters) => Stub_getFractalParameters(t, c, rep);
      ELSE
        StubLib.RaiseUnmarshalFailure();
      END;
    EXCEPT
    END;
  END Invoke;

PROCEDURE Stub_getFractalParameters(
    self: FractalNetObj.Fractal;
    c: StubLib.Conn;
    <* NOWARN *> rep: StubLib.DataRep) RAISES {NetObj.Error, Rd.Failure,
    Wr.Failure, Thread.Alerted}=
  VAR res: FractalNetObj.FractalParams;
      dataPresent: BOOLEAN <* NOWARN *>;

  BEGIN
    res := self.getFractalParameters();
    StubLib.StartResult(c);
    StubLib.OutInt32(c, ORD(ReturnCodes.OK));
    StubLib.OutRef(c, res.type);
    StubLib.OutInteger(c, res.sx);
    StubLib.OutInteger(c, res.sy);
    StubLib.OutReal(c, res.xmin);
    StubLib.OutReal(c, res.xmax);
    StubLib.OutReal(c, res.ymin);
    StubLib.OutReal(c, res.ymax);
    StubLib.OutInteger(c, res.maxiter);

  END Stub_getFractalParameters;

BEGIN
  StubLib.Register(TYPECODE(FractalNetObj.Fractal), 1, TYPECODE(Surrogate_FractalNetObj_Fractal), Invoke);
END FractalNetObj_Fractal_v1.
