INTERFACE FractalNetObj;
IMPORT NetObj;
IMPORT Ctypes;
FROM Thread IMPORT Alerted;

EXCEPTION Reject(TEXT);

TYPE
  PixMap = REF ARRAY OF ARRAY OF INTEGER;

  MouseInfo = RECORD
    button: Ctypes.int;
    x: Ctypes.double;
    y: Ctypes.double;
  END;

  MouseInfoStar = REF MouseInfo;

  ImageRec = RECORD
    width,height: Ctypes.int;
    data: PixMap;
  END;

  ImageStar = REF ImageRec;

  FractalParams = RECORD 
    type: TEXT;
		sx: INTEGER; sy: INTEGER; xmin: REAL; xmax: REAL;
		ymin: REAL; ymax: REAL; maxiter: INTEGER;
  END;

  T = NetObj.T OBJECT METHODS
    requestFractal(): Fractal RAISES {NetObj.Error, Alerted};
    returnResults(f: FractalParams; pixmap: PixMap) RAISES {NetObj.Error, Alerted};
  END;

  Fractal = NetObj.T OBJECT METHODS
    getFractalParameters(): FractalParams RAISES {NetObj.Error, Alerted}; 
  END;

<*EXTERNAL*> PROCEDURE DisplayFractal(image: ImageStar; crossHairs: Ctypes.int);
<*EXTERNAL*> PROCEDURE InitUI(width: Ctypes.int; height: Ctypes.int);
<*EXTERNAL*> PROCEDURE getMouseAction(): MouseInfoStar;

END FractalNetObj.
