#include <stdio.h>
#include <g2.h>

typedef struct MouseInfo {
  int button;
  double x,y;
} MouseInfo;

typedef struct ImageRec {
  int width,height;
  int ***data;
} ImageRec;

int d;

int getPixel (ImageRec *image, int x, int y)
{
  int height = image->height;
  int width = image->width;
  if( x >= width ) return -1;
  if( y >= height ) return -1;
  int **matrix = *(image->data);
  return (int) matrix[x*height + y];
}

MouseInfo * getMouseAction(void)
{
  MouseInfo *mouse;

  mouse = malloc(sizeof(MouseInfo));
  g2_query_pointer(d,&(mouse->x),&(mouse->y),&(mouse->button));
  while(mouse->button != 256 && mouse->button != 1024) {
    g2_query_pointer(d,&(mouse->x),&(mouse->y),&(mouse->button));
    usleep(1000);
  }
  return mouse; 
}

void InitUI(int width,int height) {
  d = g2_open_X11(height,width);
}

void DisplayFractal(ImageRec *image, int crossHairs) {
  int x=0;
  int y=0;
  int pixel;
  int height = image->height;
  int width = image->width;
  int **matrix = *(image->data);

  g2_image(d,0,0,height,width,matrix);
  if( crossHairs ) {
    g2_pen(d,0);
    g2_line(d,height/2,0,height/2,width);
    g2_line(d,0,width/2,height,width/2);
  }
};

